import SEP.sep_socket
import string
import os
import sys
import SEP.spawn
import SEP.paths
import SEP.util

class mpi:
   def __init__(self,verb=None):
      self.mpi_com=SEP.paths.mpibindir+os.sep+"mpirun"
      self.verb=None
      self.mpi_nolocal="-nolocal"
      self.partition_func=SEP.paths.sepbindir+os.sep+"PartitionM"
      self.collect_func=SEP.paths.sepbindir+os.sep+"CollectM"

   def  local_com(self,hosts):
      mach=SEP.util.temp_file("mach")
      args=[self.mpi_com,"-np",str(int(len(hosts))+1),"-machinefile",mach]
      try: f = open (mach,"w")   #OPEN THE FILE
      except:
        raise SEP.util.err, "trouble opening temporary file "+mach
      for host in hosts:
        f.write(host+"\n")
      f.close()
      return args,mach

   def collect(self, parfile, combofile,sect_list,mach_list,axis,extra_args):
    coms=[self.collect_func,"master_data=0","outtag="+combofile,"intag="+parfile,"axis="+str(axis)]
    a=[]
    for isect in sect_list: a.append(str(isect+1))
    coms.append("assign="+string.join(a,","))
    if extra_args != None: coms.extend(extra_args)
    mpi_args,host_file=self.local_com(SEP.util.condense(mach_list))
    SEP.spawn.run_mpi_wait(coms,mpi_args,self.verb)
    SEP.spawn.run_wait(["rm",host_file])

   def distribute(self, parfile, combofile,isect_list,sect_list,mach_list,axis):
    coms=[self.partition_func,"master_data=0","intag="+combofile,"outtag="+parfile,"axis="+str(axis)]
    b=[]
    for isect in isect_list: b.append(str(isect+1))
    coms.append("assign="+string.join(b,","))
    mpi_args,host_file=self.local_com(mach_list)
    SEP.spawn.run_mpi_wait(coms,mpi_args,self.verb)
    SEP.spawn.run_wait(["rm",host_file])

   def nolocal_com(self,hosts):
      mach=SEP.util.temp_file("mach")
      args=[self.mpi_com,"-nolocal","-np",int(len(hosts)),"-machinefile",mach]
      try: f = open (mach,"w")   #OPEN THE FILE
      except:
        raise SEP.util.err, "trouble opening temporary file "+mach
      for host in hosts:
        f.write(host+"\n")
      f.close()
      return args,mach
