import re
import string
import pwd
import sys
import os
import time
import SEP.util
from math import *


class sep_pars:
  def __init__(self,file=None,name=None,seppar=None):
     self.params={}
     self.added={}
     self.iamstring={}
     self.qbase="A1b2C"
     self.name="None"
     self.mylines=[]
     if file != None: self.init_file(file)
     elif seppar != None:  
       if name !=None: self.init_seppar(seppar,name)
       else: 
         raise SEP.util.err,"Must provide the name when initializing a sep_par"
     elif name !=None: self.name=name
     else:
       raise SEP.util.err, "Must provide name or file when creating "
       

  def init_seppar(self,seppar,name):
    for par,val in seppar.params.items():
      self.params[par]=val
    for par,val in seppar.added.items():
      self.added[par]=val
    for par,val in seppar.iamstring.items():
      self.iamstring[par]=val
    self.name=name
    self.mylines = seppar.mylines

  def init_file(self,file):
    try: f = open (file)   #OPEN THE FILE
    except:
      raise SEP.util.err, 'Trouble opening file for reading', file
    self.mylines = f.readlines()  #READ IN THE ENTIRE FILE TO LINES
    f.close()
    self.build_database(file)
    self.name=file

  def build_database(self,file):
    try: f = open (file)   #OPEN THE FILE
    except:
      raise SEP.util.err, 'Trouble opening file for reading', file
    lines = f.readlines()  #READ IN THE ENTIRE FILE TO LINES
    parq1=re.compile('(\S+)="(\S+)"')
    parq2=re.compile("(\S+)='(\S+)'")
    parS=re.compile('(\S+)=(\S+)')
    for line in lines:
      args=line.split()
      comment=0
      for arg in args:
        if arg[0]=="#": comment=1
        if comment!=1:
          q=0
          res=parq1.search(arg)
          if  res: q=1
          else:
            res=parq2.search(arg)
            if res: q=1
            else:
              res=parS.search(arg)
        if res:
          self.params[res.group(1)]=res.group(2)
          if q==1: self.iamstring[res.group(1)]=1
    f.close()  

  def par(self,p,default=None):
    if self.params.has_key(p):
      if self.iamstring.has_key(p): return self.params[p],1
      return self.not_string(self.params[p])
    elif default != None:
      if default[0]=='"' or default[0]=="'": return default,1
      return self.not_string(self.params[p])
    else:
       return None,0

  def write_pars(self,file):
    try: f = open (file,"w")   #OPEN THE FILE
    except:
      raise SEP.util.err, 'Trouble opening file for writing:', file
    for par,item in self.params.items():
      if self.iamstring.has_key(par):
        f.write("\t"+par+'="'+str(item)+'"\n')
      else:
        f.write("\t"+par+'='+str(item)+"\n")
    f.close()

  def write_new_pars(self,file):
    try: f = open (file,"w")   #OPEN THE FILE
    except:
      raise SEP.util.err, 'Trouble opening file writing:'+ file
    for line in self.mylines:
      f.write(line)
    f.write(sys.argv[0]+":   "+pwd.getpwuid(os.getuid())[0])
    f.write("@"+os.uname()[1]+" "+
    time.strftime("%a %b %d %H:%M:%S %Y",time.localtime(int(time.time())))+"\n")

    host=os.uname()[1]
    for par,item in self.added.items():
      if self.iamstring.has_key(par):
        f.write("\t"+par+'="'+str(item)+'"\n')
      else:
        f.write("\t"+par+'='+str(item)+"\n")
    f.close()

  def add_param(self,par,val,type="str"):
    if re.search("\s+",str(val)): self.iamstring[par]=1
    if type == "int":
      self.params[par]=int(val)
      self.added[par]=int(val)
    else:
      self.params[par]=val
      self.added[par]=val
     
  def not_string(self,cc):
     if re.search(",",str(cc)):
       vals=cc.split(",")
       return vals,len(vals)
     else:
       return cc,1
